#!/usr/bin/env node
import { __awaiter, __generator, __read } from "tslib";
import fs from 'fs';
import { start, getBashStubs } from '../';
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var _a, mode, jsFile, bashCoprocName, _b, input, output, commands, _c, _d, e_1;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    _e.trys.push([0, 7, 8, 9]);
                    _a = __read(process.argv, 5), mode = _a[2], jsFile = _a[3], bashCoprocName = _a[4];
                    _b = mode;
                    switch (_b) {
                        case 'coproc': return [3 /*break*/, 1];
                        case 'bootstrap': return [3 /*break*/, 4];
                    }
                    return [3 /*break*/, 5];
                case 1:
                    input = fs.createReadStream('', { fd: 3 });
                    input.pause();
                    output = fs.createWriteStream('', { fd: 4 });
                    commands = require(jsFile).default;
                    _d = (_c = output).write;
                    return [4 /*yield*/, getBashStubs(bashCoprocName, commands)];
                case 2:
                    _d.apply(_c, [_e.sent()]);
                    return [4 /*yield*/, start({
                            commands: commands,
                            input: input,
                            output: output
                        })];
                case 3:
                    _e.sent();
                    return [3 /*break*/, 6];
                case 4:
                    console.log("\n                    # Launch coprocess\n                    {\n                        coproc " + bashCoprocName + " { bash-node-ipc coproc " + jsFile + " " + bashCoprocName + "; } 3<&0 4>&1 0<&5 1>&6\n                    } 5<&0 6>&1\n                    # Read stubs from coprocess, then eval them\n                    bash_node_ipc_stubs=''\n                    while IFS='' read -r -d $'\n' bash_node_ipc_stub_line\n                    do\n                        [[ \"$bash_node_ipc_stub_line\" != \"EOF\" ]] || break\n                        bash_node_ipc_stubs+=\"$bash_node_ipc_stub_line\"$'\\n'\n                    done <&\"${node_coproc[0]}\"\n                    eval \"$bash_node_ipc_stubs\"\n                ");
                    return [3 /*break*/, 6];
                case 5: throw new Error("Unexpected mode " + mode);
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_1 = _e.sent();
                    console.error('Unhandled error in bash-node-ipc main(): ' + e_1);
                    return [3 /*break*/, 9];
                case 8:
                    fs.closeSync(0);
                    fs.closeSync(1);
                    fs.closeSync(2);
                    // fs.closeSync(3);
                    fs.closeSync(4);
                    return [7 /*endfinally*/];
                case 9: return [2 /*return*/];
            }
        });
    });
}
main();
//# sourceMappingURL=bash-node-ipc.mjs.map