#!/usr/bin/env ts-node-to
/// <reference types="node" />
import { Readable, Writable } from 'stream';
/**
 * Wrap an async iterator so that .return() is not passed to the wrapped `iter`.
 * This means you can `for await (const foo of noReturn(iter))`, `break;` out of
 * the loop, and it won't tell `iter` to stop early.
 */
export declare function noReturn<T>(iter: AsyncIterableIterator<T>): AsyncIterableIterator<T>;
export declare function start(opts: {
    commands: any;
    input: Readable;
    output: Writable;
}): Promise<void>;
export declare function getBashStubs(bashCoprocName: string, commands: any): Promise<string>;
export declare const STUBS_EOF_MARKER = "\nEOF\n";
//# sourceMappingURL=index.d.ts.map